%{
#define YYSTYPE char *
#ifndef PARSE_DEBUG
#include "Odl.h"
#endif
#include "Odl.tab.h"
#include <string.h>
int lineNum=0;
%}

digits          [0-9]+
number          ({digits}(\.{digits}?)?)|(\.{digits})
S               [ \t]*

ident           [a-zA-Z][a-zA-Z0-9_]*

%s PRECEDING_STATE
%%

"attribute"                           {return ATTRIBUTE;}
"readonly"                            {return READONLY;}
"long"                                {return LONG;}
"short"                               {return SHORT;}
"unsigned"                            {return UNSIGNED;}
"class"                               {return CLASS;}
"char"                                {return CHAR;}
"boolean"                             {return BOOLEAN;}
"octet"                               {return OCTET;}
"float"                               {return FLOAT;}
"double"                              {return DOUBLE;}
"string"                              {return STRING;}

{ident}                               {yylval = (char *)malloc(strlen(yytext)+1);strcpy(yylval,yytext); return IDENT;}

[ \t]                                 ;
\n                                    lineNum ++;   
.                                     return yytext[0];

%%
