from Numeric import *
c1=3.74e-16
c2=1.44e-2

__version__="$Id: planck.py,v 1.3 2000/10/11 13:27:17 phil Exp phil $"

def planck(wavel,Temp):
    c1=3.74e-16
    c2=1.44e-2
    Blambda=c1/pi/(wavel**5.*(exp(c2/(wavel*Temp)) -1)) 
    return Blambda

def trueplanck(wavel,Temp):
    h=6.63e-34
    c=3.e8
    c1=2.*h*c**2.
    kb=1.38e-23
    c2=h*c/kb
    Blambda=c1/(wavel**5.*(exp(c2/(wavel*Temp)) -1)) 
    return Blambda

def planckInvert(wavel,Blambda):
    #note this is approximate!
    c1=3.74e-16
    c2=1.44e-2
    Tbright=c2/(wavel*(log(c1) -log(pi*wavel**5.) - log(Blambda)))
    return Tbright

def planckInt(wavel,Temp):
    dlamb=wavel[1:] - wavel[:-1]
    bbr=planck(wavel[:-1],Temp)
    integ=sum(bbr*dlamb)
    return integ

#this trick will run  the following script if
#the file planck.py is run as a program, but won't
#if  planck.py is imported from another  module


if __name__ ==  '__main__':

    Temp=300.
    #check to see how good this approx. is:

    wavel=10.e-6

    bbr= planck(wavel,Temp)
    bt = planckInvert(wavel,bbr)

    print "Temp (K), bbr (W/m^2/sr/m), bt (K): ",Temp,bbr,bt

    wavel=arange(1.,50.,.1)*1.e-6
    print "size of  wavel: ",wavel.shape

    bbr=planck(wavel,Temp)
    print "size of  bbr: ",bbr.shape
    print "type of bbr:", type(bbr)

    totrad=planckInt(wavel,Temp)
    stefan=5.67e-8*Temp**4.
    print "approx integ: ",totrad," stefan-boltzman: ",stefan/pi
    
    




