
import sys
import libxsltmod


class MessageHandler:
    def __init__(self):
        self.content = ''
    def write(self, msg):
        self.content = self.content + msg
    def getContent(self):
        return self.content


def translate(stylesheetName, infileName, outfileName):
    print 'Transforming: %s --> %s' % (infileName, outfileName)
    handler = MessageHandler()
    result = libxsltmod.translate_to_string('f', stylesheetName,
        'f', infileName, handler)
    errors = handler.getContent()
    if errors:
        print errors
        return
    f = open(outfileName, 'w')
    f.write(result)
    f.close()


USAGE_STRING = """\
Usage: python test_to_string.py <stylesheetfile> <xmlfile> <outfile>
Example:
    python test_to_string.py camping_format.xsl camping_list1.xml camping_list1.html
"""

def usage():
    print USAGE_STRING
    sys.exit(-1)


def main():
    args = sys.argv[1:]
    if len(args) != 3:
        usage()
    stylesheetName = args[0]
    infileName = args[1]
    outfileName = args[2]
    translate(stylesheetName, infileName, outfileName)


if __name__ == '__main__':
    main()

