#! python
#
# Minimal interface to the Internet telnet protocol.
#
# It refuses all telnet options and does not recognize any of the other
# telnet commands, but can still be used to connect in line-by-line mode.
# Modified from telnet example in original python 2.2 distribution...
# The code is realy theirs.
#
# 
# Usage: telnet host [port]
#
# The port may be a service name or a decimal port number;
# it defaults to 'telnet'.
#
# 2002 PythonD 2.2 Release, deckerben, http://members.lycos.co.uk/bdeck
# Modification from original code includes use of select() and minor...



import sys, os, time, select
from socket import *

BUFSIZE = 1024
SIGSEND = 0.65	# wait on our turn to send data

# Telnet protocol characters

IAC  = chr(255)	# Interpret as command
DONT = chr(254)
DO   = chr(253)
WONT = chr(252)
WILL = chr(251)

def main():#
	count = (1,2,3)
	host = sys.argv[1]
	sock_bit = chr(66)
	try:
		hostaddr = gethostbyname(host)
	except error:
		sys.stderr.write(sys.argv[1] + ': bad host name\n')
		sys.exit(2)
	#
	if len(sys.argv) > 2:
		servname = sys.argv[2]
	else:
		servname = 'telnet'
	#
	if '0' <= servname[:1] <= '9':
		port = eval(servname)
	else:
		try:
			port = getservbyname(servname, 'tcp')
		except error:
			sys.stderr.write(servname + ': bad tcp service name\n')
			sys.exit(2)
	#
	s = socket(AF_INET, SOCK_STREAM)
	#
	try:
		s.connect((host, port))
	except error, msg:
		sys.stderr.write('connect failed: ' + `msg` + '\n')
		sys.exit(1)

	# parent -- read socket, write stdout
	while 1:
		nosig=3
		def readsock(data):
			iac = 0		# Interpret next char as command
			opt = ''	# Interpret next char as option
			# print ord(sock_bit) # for displaying test char
			cleandata = ''
			for c in data:
				if opt:
					print ord(c)
					s.send(opt + c)
					opt = ''
				elif iac:
					iac = 0
					if c == IAC:
						cleandata = cleandata + c
					elif c in (DO, DONT):
						if c == DO: print '(DO)',
						else: print '(DONT)',
						opt = IAC + WONT
					elif c in (WILL, WONT):
						if c == WILL: print '(WILL)',
						else: print '(WONT)',
						opt = IAC + DONT
					else:
						print '(command)', ord(c)
				elif c == IAC:
					iac = 1
					print '(IAC)',
				else:
					cleandata = cleandata + c
			sys.stdout.write(cleandata)
			sys.stdout.flush()

		def sendsock():
			line = sys.stdin.readline()
			s.send(line)

		# if sock_bit != '': readsock(sock_bit)
		startedSelect=time.time()
		SIGRECV=select.select([s],[],[],SIGSEND)
    		if SIGRECV[0]==[]: # No more data
			sendsock()
		else:
			data=s.recv(BUFSIZE)
			readsock(data)
	
try:
	main()
except KeyboardInterrupt:
	pass
